unit uDroites;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, Math;

type
  TForm1 = class(TForm)
    Image1: TImage;
    btnAfficheEfface: TSpeedButton;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnAfficheEffaceClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var BMP : tBitMap;

// palette de couleurs dgrades aux couleurs de l'arc-en-ciel :

var PalArc : array[0..360] of tColor;
procedure PrecalculPalArc;
var       i:integer;
begin     for i:=0 to 360 do
           Case (i div 60) of
              0,6 : PalArc[i]:=rgb(255,(i Mod 60)*255 div 60,0);
              1   : PalArc[i]:=rgb(255-(i Mod 60)*255 div 60,255,0);
              2   : PalArc[i]:=rgb(0,255,(i Mod 60)*255 div 60);
              3   : PalArc[i]:=rgb(0,255-(i Mod 60)*255 div 60,255);
              4   : PalArc[i]:=rgb((i Mod 60)*255 div 60,0,255);
              5   : PalArc[i]:=rgb(255,0,255-(i Mod 60)*255 div 60);
           end;
end;

// Les droites :

type tTraceMode = (tmAffiche,tmEfface,tmCopy);

procedure DrawSegmentBis(const BMP: TBitMap; x1,y1,x2,y2,CoulPen: Integer; TraceMode : tTraceMode); // Caribensila mod GG
type      PCardinal = ^Cardinal;
var       e,dx,dy : Integer;       //Erreur, variation en X et en Y.
          Scan0   : Integer;       //Valeur du pointeur d'entre dans le Bitmap.
          Scan    : Integer;       //Pointeur temporaire destin  tre incrment.
          Bpp     : Integer;       //Byte per pixel du Bitmap.
          pCoulPen: TRGBQuad;    //Pointe sur la couleur du crayon
          pCoulDec: TRGBQuad;    //Pointe sur la couleur dcale formant Flag.
          MLS     : Integer;       //Memory Line Size (en bytes) du Bitmap.
          W,H     : Integer;       //Hauteur et largeur du Bitmap.
          CoulDec : tColor;        //Couleur = CoulPen dcale de D = 2 formant Flag
          RD,GD,BD: byte;          //Composantes de CoulDec
          clBack  : tColor;        //Couleur Arrire-plan
          clPNX   : tColor;        //Couleur NotXor de clBack avec CoulPen
          clDNX   : tColor;        //Couleur NotXor de clBack avec CoulDec
          PixMin,PixMax : Integer; //Bornes de l'intervalle d'appartenance du pointeur au BitMap

          procedure GSPixel;
          begin     Scan := Scan0;
                    Inc(Scan, y1*MLS + x1*Bpp);
                    if not ((Scan>=PixMin) and (Scan<=PixMax)) then EXIT; // Si on se trouve en-dehors du BMP
                    {case TraceMode of
                         tmAffiche : if PRGBQuad(scan)^.rgbReserved = 0 then
                                        PCardinal(scan)^ := not (PCardinal(scan)^ XOR coulPen);
                         tmEfface  : if PRGBQuad(scan)^.rgbReserved = $FF then
                                     PCardinal(scan)^ := not (PCardinal(scan)^ XOR coulPen);
                         else PRGBQuad(Scan)^:=pCoulPen; //<- pmCopy (utilis uniquement lors d'un appel pour un trac de finition)
                    end; }
                    case TraceMode of
                         tmAffiche : if PRGBQuad(scan)^.rgbReserved = $FF then
                                        PCardinal(scan)^ := not (PCardinal(scan)^ XOR coulPen);
                         tmEfface  : if PRGBQuad(scan)^.rgbReserved = 0 then
                                     PCardinal(scan)^ := not (PCardinal(scan)^ XOR coulPen);
                         else PRGBQuad(Scan)^:=pCoulPen; //<- pmCopy (utilis uniquement lors d'un appel pour un trac de finition)
                    end;
          end; // GSPixel

begin
          // INITIALISATION DES VARIABLES :
          // NB: Ceci peut tre fait ailleurs dans le code, cependant le tampon mmoire n'est pas garanti
          // comme tant cohrent (oprations GDI rcentes, par exemple). Il est donc conseill d'appeler
          // la mthode ScanLine[] aprs chaque opration  risque, ou avant chaque srie d'accs  la
          // mmoire afin de synchroniser le tampon.
          case BMP.PixelFormat of
               pf24bit : Bpp:=3;
               pf32bit : Bpp:=4;
               else begin Showmessage('24 ou 32 bits uniquement !'); EXIT; end;
          end;

          Scan0 := Integer(BMP.ScanLine[0]);
          MLS   := Integer(BMP.ScanLine[1]) - Scan0; //Memory Line Size
          W     := BMP.Width ;
          H     := BMP.Height;
          Bpp   := Abs(MLS div W);
          if Integer(BMP.ScanLine[H-1]) < Scan0 then begin  //Si c'est un  Bottom-Up DIB...
	     PixMin := Integer(BMP.ScanLine[H-1]);
  	     PixMax := Scan0 + Bpp*W - Bpp;
          end else begin //sinon c'est un Top-Down DIB...
  	      PixMin := Scan0;
              PixMax :=Integer(BMP.ScanLine[H-1]) + Bpp*W - Bpp;
          end;

          try  //DEBUT DE L'ALGO
                dx:= x2-x1;
                if dx<>0 then begin
                   if dx>0 then begin
                      dy:= y2-y1;
                      if dy<>0 then begin
                        if dy>0 then begin
                            if dx>=dy then begin
                               e:= dx;
                               dx:= e  shl 1;
                               dy:= dy shl 1;
                               repeat
                                 GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                 Inc(x1);
                                 e  := e - dy;
                                 if e<0 then begin
                                    Inc(y1);
                                    Inc(e,dx);
                                 end;
                               until x1=x2;
                            end
                            else begin // dx<dy
                                 e  := dy;
                                 dy := e  shl 1;
                                 dx := dx shl 1;
                                 repeat
                                   GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                   Inc(y1);
                                   Dec(e,dx);
                                   if e < 0 then begin
                                      Inc(x1);
                                      Inc(e,dy)
                                   end;
                                 until y1 = y2;
                            end; // if dx
                        end // if dy>0
                        else begin // dy <=0
                             if dx >= -dy then begin
                                e  := dx;
                                dx := e  shl 1;
                                dy := dy shl 1;
                                repeat
                                  GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                  Inc(x1);
                                  Inc(e,dy);
                                  if e < 0 then begin
                                     Dec(y1);
                                     Inc(e,dx);
                                  end;
                                until x1 = x2;
                             end // if dx >= -dy
                        else begin // dx < -dy
                             e  := dy;
                             dy := e  shl 1;
                             dx := dx shl 1;
                             repeat
                               GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                               Dec(y1);
                               Inc(e,dx);
                               if e > 0 then begin
                                  Inc(x1);
                                  Inc(e,dy);
                               end;
                             until y1 = y2;
                        end; // dx < -dy
                      end; // if dy<>0
                   end // if dx>0
                   else begin // dx<=0
                        repeat
                           GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                           Inc(x1);
                        until x1 = x2 ;
                   end; // dx<=0
                end
                else begin
                     dy := y2 - y1;
                     if dy <> 0 then begin
                        if dy > 0 then begin
                           if -dx >= dy then begin
                              e  := dx;
                              dx := e  shl 1;
                              dy := dy shl 1;
                              repeat
                                GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                Dec(x1);
                                Inc(e,dy);
                                if e >= 0 then begin
                                   Inc(y1);
                                   Inc(e,dx);
                                end
                              until x1 = x2;   end
                           else begin // -dx < dy
                                e  := dy;
                                dy := e  shl 1;
                                dx := dx shl 1;
                                repeat
                                  GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                  Inc(y1);
                                  Inc(e,dx);
                                  if e <= 0 then begin
                                     Dec(x1);
                                     Inc(e,dy);
                                  end;
                                until y1 = y2;
                           end; // -dx < dy
                        end //if dy > 0
                        else begin // dy <=0
                             if dx <= dy then begin
                                e  := dx;
                                dx := e  shl 1;
                                dy := dy shl 1;
                                repeat
                                  GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                  Dec(x1);
                                  Dec(e,dy);
                                  if e >= 0 then begin
                                     Dec(y1);
                                     Inc(e,dx);
                                  end;
                                until x1 = x2;
                             end // if dx <= dy
                             else begin // dx > dy
                                  e  := dy;
                                  dy := e  shl 1;
                                  dx := dx shl 1;
                                  repeat
                                    GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                                    Dec(y1);
                                    Dec(e,dx);
                                    if e >= 0 then begin
                                       Dec(x1);
                                       Inc(e,dy);
                                    end;
                                  until y1 = y2;
                             end; // dx > dy
                        end; // dy <=0
                     end //if dy <> 0
                     else begin
                          repeat
                            GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                            Dec(x1);
                          until x1 = x2 ;
                     end;
                end;
          end
          else begin
               dy := y2 - y1;
               if dy  <> 0 then begin
                  if dy > 0 then begin
                     repeat
                       GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                       Inc(y1);
                       until y1 = y2 ;
                  end
                  else begin
                       repeat
                         GSPixel; // Display sauf si on se trouve en-dehors du BitMap
                         Dec(y1);
                       until y1 = y2 ;
                  end;
               end;
          end;
    finally
    end;
end; // DrawSegmentBis

procedure DrawLine( BMP : TBitMap; xo,yo,xe,ye, epTrait : integer; CoulPen : TColor; TraceMode : tTraceMode);
var       Theta,miEp,si,co,mis,mic,sinco,cosco,
          ep,x,y,dx,dy,xo1,yo1,xe1,ye1,xo2,yo2,xe2,ye2,a,b,xorMin,xerMax,yorMin,yerMax,rr,d,u : Extended;
          iy,ix,yoMin,yeMax,xoMin,xeMax,r,i,j,xoc,xec,yoc,yec : integer;
begin     dx:=xe-xo; dy:=ye-yo;
          miep:=epTrait/2; rr:=miEp; ep:=0;
          if dx=0 then // Verticale
          begin xo1:=xo - miep; xo2:=xo + miep; yo1:=min(yo,ye); ye1:=max(yo,ye);
                for ix:=trunc(xo1) to trunc(xo2) do begin
                    // Embouts arrondis :
                    d:=abs(rr-ep); if rr>d then u:=sqrt(sqr(rr)-sqr(d)) else u:=0;
                    yoMin:=trunc(yo1-u); yeMax:=trunc(ye1+u);
                    // Trac du segment incluant les prolongements pour embouts arrondis :
                    DrawSegmentBis(BMP,ix,yoMin,ix,yeMax,CoulPen,TraceMode);
                    ep:=ep+1;
                end;
                EXIT;
          end;
          if ye=yo then // Horizontale
          begin yo1:=yo - miep; yo2:=yo + miep; xo1:=min(xo,xe); xe1:=max(xo,xe);
                for iy:=trunc(yo1) to trunc(yo2) do begin
                    // Embouts arrondis :
                    d:=abs(rr-ep); if rr>d then u:=sqrt(sqr(rr)-sqr(d)) else u:=0;
                    xoMin:=trunc(xo1-u); xeMax:=trunc(xe1+u);
                    // Trac du segment incluant les prolongements pour embouts arrondis :
                    DrawSegmentBis(BMP,xoMin,iy,xeMax,iy,CoulPen,TraceMode);
                    ep:=ep+1;
                end;
                EXIT;
          end;
          // Droites inclines
          Theta:=arcTan2(ye-yo,xe-xo);      a:=tan(Theta);
          si:=sin(Theta);   co:=cos(Theta); mis:=miep*si;  mic:=miep*co;
          xo1:=xo + mis;    yo1:=yo - mic;  xo2:=xo - mis; yo2:=yo + mic;
          xe1:=xe + mis;    ye1:=ye - mic;  xe2:=xe - mis; ye2:=ye + mic;
          sinco:=sin(Pi/2-theta);           cosco:=cos(Pi/2-theta);
          dy:=abs(ye-yo); dx:=abs(xe-xo);
          if dy>=dx then // "y = a.x + b" --> x:= (y - b)/a
          begin yorMin:=min(yo1,ye1); yerMax:=max(yo1,ye1);
                b:=ye1 - a*xe1; ep:=0; si:=abs(si);
                repeat // Embouts arrondis :
                       d:=abs(rr-ep); if rr>d then u:=si*sqrt(sqr(rr)-sqr(d)) else u:=0;
                       xoc:=trunc((yorMin-u-b)/a);
                       xec:=trunc((yerMax+u-b)/a);
                       // Trac du segment incluant les prolongements pour embouts arrondis :
                       DrawSegmentBis(BMP,xoc,trunc(yorMin-u),xec,trunc(yerMax+u),CoulPen,TraceMode);
                       if TraceMode<>tmCopy then begin
                           ep:=ep+1;
                           b:=b+1/sinco;
                           yorMin:=yorMin+sinco;
                           yerMax:=yerMax+sinco;
                       end else begin // si tmCopy alors passe de finition resserre
                           ep:=ep+0.5;
                           b:=b+0.5/sinco;
                           yorMin:=yorMin+0.5*sinco;
                           yerMax:=yerMax+0.5*sinco;
                       end;
                until (ep>=epTrait);
                EXIT;
          end else // dy < dx -> y = a.x + b
          begin b:=yo1 - a*xo1; ep:=0; co:=abs(co);
                xo2:=min(xo1,xe1); xe2:=max(xo1,xe1); xorMin:=xo2; xerMax:=xe2;
                repeat // Embouts arrondis :
                       d:=abs(rr-ep); if rr>d then u:=co*sqrt(sqr(rr)-sqr(d)) else u:=0;
                       // Trac du segment incluant les prolongements pour embouts arrondis :
                       yoc:=trunc(a*(xorMin-u) + b);
                       yec:=trunc(a*(xerMax+u) + b);
                       DrawSegmentBis(BMP,trunc(xorMin-u),yoc, trunc(xerMax+u),yec,CoulPen,TraceMode);
                       if TraceMode<>tmCopy then begin
                           ep:=ep+1;
                           b:=b+1/sinco;
                           xorMin:=xorMin-cosco;
                           xerMax:=xerMax-cosco;
                       end else begin // si tmCopy alors passe de finition resserre
                           ep:=ep+0.5;
                           b:=b+0.5/sinco;
                           xorMin:=xorMin-0.5*cosco;
                           xerMax:=xerMax-0.5*cosco;
                       end;
                until (ep>=epTrait);
          end;
end; // DrawLine

// Utilisation :

var       TraceMode : tTraceMode;

procedure TForm1.FormCreate(Sender: TObject);
begin     PrecalculPalArc;
          BMP := tBitMap.create;
          BMP.PixelFormat:=pf24bit;
          TraceMode := tmEfface;
end;

procedure TForm1.FormResize(Sender: TObject);
begin     image1.height:=clientHeight-40;
          with BMP do begin
               width:=image1.width; height:=image1.height;
               canvas.brush.color:=clWhite;
               canvas.fillRect(canvas.clipRect);
          end;
          image1.Picture.Bitmap.Assign(BMP);
          TraceMode := tmEfface;
          btnAfficheEffaceClick(Sender);
end;

procedure TForm1.btnAfficheEffaceClick(Sender: TObject);
var       i,RayI,RayE,xc,yc,xo,yo,xe,ye : integer;
begin     if TraceMode=tmEfface then TraceMode:=tmAffiche else TraceMode:=tmEfface;
          //TraceMode:=tmCopy;
          xc:=300; yc:=300; RayI:=80; RayE:=200;
          for i:=0 to 36 do begin
              xo:=round(xc+RayI*cos(DegToRad(i*10)));
              yo:=round(yc+RayI*sin(DegToRad(i*10)));
              xe:=round(xc+RayE*cos(DegToRad(i*10)));
              ye:=round(yc+RayE*sin(DegToRad(i*10)));
              DrawLine(BMP,xo,yo,xe,ye, 16, PalArc[i*10], TraceMode);  // <- droites paisse de 16 pixels
              //DrawSegmentBis(BMP,xo,yo,xe,ye, PalArc[i*10], TraceMode); <- droites paisse d'un seul pixel
          end;

          DrawLine(BMP,xc-40,600,xc+40,400, 40, clGreen, TraceMode);
          DrawLine(BMP,xc-40,400,xc+40,600, 40, clRed,   TraceMode);
           with BMP.canvas do begin
                brush.Style:=bsSolid;
                if TraceMode=tmAffiche then textOut(xc-100, 40, 'Mode Affiche');
                if TraceMode=tmEfface then textOut(xc-100, 40,  'Mode Efface ');
                if TraceMode=tmCopy then textOut(xc-100, 40,    'Mode Copy   ');
           end;

          Image1.Picture.bitmap.Assign(BMP);
          Image1.Repaint;
end;

end.
